#ifndef MAKEDEPEND
#include <ctime>
#endif

class expr_time : public expr
{
	char which;
public:
	expr_time(string &input)
	{
		exprp e = expr::load(input, prio_high);
		if(!e)
			valid = false;
		else if(!e->isconst || e->type != str)
			valid = false;
		else
		{
			const string s = e->getstr();
			
			if(s=="h")which='h';
			else if(s=="m")which='m';
			else if(s=="s")which='s';
			else if(s=="Y")which='Y';
			else if(s=="M")which='M';
			else if(s=="D")which='D';
			else valid = false;
		}
		type = num;
	}	
	virtual exprp calculate(calculate_args_notused) const
	{
		time_t t = time(NULL);
		struct tm *TM = localtime(&t);
		expr_floattype d=0.0;
		
		switch(which)
		{
			case 'h': d = TM->tm_hour; break;
			case 'm': d = TM->tm_min; break;
			case 's': d = TM->tm_sec; break;
			case 'Y': d = TM->tm_year+1900; break;
			case 'M': d = TM->tm_mon+1; break;
			case 'D': d = TM->tm_mday; break;
		}
		return new expr_number(d);
	}
	virtual const string getname() const
	{
		return string("time('") + which + "')";
	}
};
