#ifndef MAKEDEPEND
 #include <string>
 #include <csignal>
 #ifndef COMPET
  #include <cstring>
 #endif
#endif
#include "expr.h"

static void sigh(int)
{
    cout << flush << "expression=\"Segmentation fault\"\n" << flush;
    exit(0);
}

#include "expr_var.h"
#include "expr_huuto.h"
int main(int argc, const char *const *argv)
{
#if 0
	exprp a = new expr_number(5);
	cout << "a start: " << a->getname() << " ja " << a->valid << endl;
	exprp c = new expr_huuto(a);
	cout << "a befor: " << a->getname() << " ja " << a->valid << endl;
	cout << "b befor: " << c->getname() << " ja " << c->valid << endl;
	exprp b = c->optimize();
	cout << "a after: " << a->getname() << " ja " << a->valid << endl;
	cout << "b after: " << b->getname() << " ja " << b->valid << endl;
	
#else
	expr a;
	string s;
	#ifndef COMPET
	if(!argc)
	#endif
		cout << "Copyright (C) 1992,2000 Bisqwit (http://iki.fi/bisqwit/)\n";
	#ifdef SIGSEGV
	signal(SIGSEGV, sigh);
	#endif
	#ifdef SIGSTKFLT
	signal(SIGSTKFLT, sigh);
	#endif
	#ifdef SIGFPE
	signal(SIGFPE, sigh);
	#endif
#ifdef COMPET
	if(argc != 4)
	{
		cout << "Competition version\nUsage: expr <expression> <start_x> <end_x> <step_x>\n";
		return 0;
	}
	expr_floattype ival = atof(argv[2]), fval = atof(argv[3]), step = atof(argv[4]);
	
	string t = argv[1];
	exprp c = a.load(t);
	
	expr_floattype sum=0.0;
	for(X=ival; X<=fval; X+=step)
	{
		exprp b = c->calculate();		
		sum += b->getnum();		
	}
	
	cout << "sum=" << sum << endl;
#else
	unsigned base=0, bits=0;
	for(int i=1; i<argc; i++)
	{
		if(strstr(argv[i], "help"))
		{
			cout << "Usage: " << argv[0] << " [-box | -help] <mathematical expression>\n";
			return 0;
		}    
		     if(!strcmp(argv[i], "-x")) base = 16, bits = 4;
		else if(!strcmp(argv[i], "-o")) base = 8,  bits = 3;
		else if(!strcmp(argv[i], "-b")) base = 2,  bits = 1;
		else
		{
			s += ' ';
			s += argv[i];
		}
	}

	if(!s.size())
	{
		cout << "Anna lauseke: " << flush;
		getline(cin, s);
	}
	exprp c = a.load(s);
	
//	cout << "trap, c='" << c->getname() << "' - (" << (void*)&c << ")\n";
	
	if(!c)
	{
		if(s.size())
			cout << "error1=`" << s << "'.\n";
		else
			cout << "Parse error -- (possibly a type mismatch somewhere)\n";
		return -1;
	}
		
	exprp b = c->calculate();
	
//	cout << "trap, b - (" << (void*)&b << ")\n";

	if(s.size())
		cout << "error2=`" << s << "'.\n";
	
	cout << "To calculate: " << c->getname() << endl;
	
	if(b)
	{
        if(base)
        {
        	expr_floattype d = b->getnum();
        	expr_longtype num = (expr_longtype)d;
        	s = "";
        	d -= num;
        	for(;;)
        	{
        		s = "0123456789ABCDEF"[num%base] + s;
        		num >>= bits;
        		if(!num)break;
        	}
	        cout << "result=" << s;
	        if(d > 0.0 && d < 1.0)
	        {
	        	cout << '.';
	        	for(int i=0; i<30; i++)
	        	{
		        	d *= base;
		        	num = (expr_longtype)d;
        			cout << "0123456789ABCDEF"[num];
        			d -= num;
        			if(d==0.0)break;
        		}
	        }
	        switch(bits)
	        {
	        	case 1: cout << " (binary)\n"; break;
	        	case 3: cout << " (octal)\n"; break;
	        	case 4: cout << " (hex)\n"; break;
	        	default: cout << " (bug)\n"; break;
	        }
        }
        else
        {
	        expr_floattype num = b->getnum();
        	cout.precision(20);
	        cout << "result=" << num << endl;
		}
        
        const string &str = b->getstr();
        const string &exp = b->getname();
        
        if(str != exp)
        {
        	if(str.size())cout << "string=\"" << str << "\"\n";
        	cout << "expression=" << exp << "\n";
    	}
	}
#endif	
	return 0;
#endif
}
